/*
 * bitStream.cpp
 *
 *  Created on: Feb 4, 2009
 *      Author: jonathanmasci
 */

#include "bitStream.h"
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdexcept>

BitStream::BitStream() : BitVector(128), _position(0)
{
  _size = 0;
}

BitStream::~BitStream() { }

void
BitStream::push_back(bool v)
{
  ++_size;
  if (_size < _buffer_size * _BIT_WORD_SIZE)
    if (v)
      set(_size - 1);
    else
      unset(_size - 1);
  else
    {
      _buffer_size *= 2;
      _buffer = (uchar *)realloc(_buffer, sizeof(*_buffer) * _buffer_size);
      if (v)
        set(_size - 1);
      else
        unset(_size - 1);
    }
}

void
BitStream::rewind()
{
  _position = 0;
}

bool
BitStream::can_read()
{
  if (_position < _size)
    return true;
  else
    return false;
}

bool
BitStream::read()
{
  if (_position < _size)
    {
      ++_position;
      return (get(_position - 1));
    }
  else
    {
      char c[15];
      sprintf(c, "%i", _position);
      throw std::out_of_range(std::string("Cannot access element ").append(c));
    }
}
