/*
 * main.cpp
 *
 *  Created on: Feb 2, 2009
 *      Author: jonathanmasci
 */

#include "bitVector.h"
#include "bitStream.h"
#include <assert.h>
#include <stdio.h>
#include <string.h>

int main(int argc, char **argv) {
  unsigned char *s = new unsigned char[10];
  memset(s, 0, 10);

  BitVector bv(1000000);
  assert(bv.size() == 1000000);
  for (unsigned int i = 0; i < bv.size(); ++i)
    assert(bv.get(i) == false);
  for (unsigned int i = 0; i < bv.size(); ++i)
    bv.set(i);
  for (unsigned int i = 0; i < bv.size(); ++i)
    assert(bv.get(i) == true);

  BitVector bv2(s, 10, 70);
  for (unsigned int i = 0; i < bv2.size(); ++i)
    assert(bv2.get(i) == false);
  for (unsigned int i = 0; i < bv2.size(); ++i)
    bv2.set(i);
  for (unsigned int i = 0; i < bv2.size(); ++i)
    assert(bv2.get(i) == true);

  bv2.flip(10);
  assert(bv2.get(10) == false);
  assert(bv2.get(9) == true);
  assert(bv2.get(11) == true);
  bv2.flip(10);
  assert(bv2.get(10) == true);
  assert(bv2.get(9) == true);
  assert(bv2.get(11) == true);

  bv2.unset(10);
  assert(bv2.get(10) == false);
  assert(bv2[10] == false);
  assert(bv2.get(9) == true);
  assert(bv2.get(11) == true);
  assert(bv2[9] == true);
  assert(bv2[11] == true);

  bv2[10] = true;
  assert(bv2[10] == true);
  assert(bv2.get(9) == true);
  assert(bv2.get(11) == true);
  assert(bv2[9] == true);
  assert(bv2[11] == true);

  bv2[10] = false;
  assert(bv2[10] == false);
  assert(bv2.get(9) == true);
  assert(bv2.get(11) == true);
  assert(bv2[9] == true);
  assert(bv2[11] == true);


  //=======
  BitStream bs;
  assert(bs.size() == 0);
  bs.push_back(true);
  assert(bs.size() == 1);

  return 0;
}
